USE <DB_NAME>
GO

/****** Object:  StoredProcedure [dbo].[allPageLockEnable]    Script Date: 11/05/2017 6:47:09 PM ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO


CREATE PROCEDURE [dbo].[allPageLockEnable] @schemaName nvarchar(30), @dbName nvarchar(30)
AS
	BEGIN
		DECLARE @indexName nvarchar(60)
		DECLARE @indexSql nvarchar(4000) 
		DECLARE @qTableName varchar(100)
		DECLARE @alterSql nvarchar(4000)
	
		CREATE TABLE #index_names (name varchar(100), table_name varchar(100))
		
		SET @indexSql = 'INSERT INTO #index_names(name, table_name) SELECT i.name, t.name FROM ' +
						@dbName + '.sys.indexes i INNER JOIN ' + @dbName +
						'.sys.tables t ON t.object_id = i.object_id'
		PRINT 'SQL query to find indexes for all tables'
		PRINT @indexSql	
		EXEC(@indexSql)	
						
		DECLARE indexes CURSOR FOR
			SELECT name, table_name
			FROM #index_names
				
		PRINT 'Setting page locks OFF for all the indexes'		
		OPEN indexes
			FETCH NEXT FROM indexes INTO @indexName, @qTableName
			WHILE @@FETCH_STATUS = 0
			BEGIN
				PRINT 'Alter query to set page lock OFF'
				SET @alterSql = 'ALTER INDEX ' + QUOTENAME(@indexName) + ' ON ' + QUOTENAME(@schemaName) + '.'
									+ QUOTENAME(@qTableName) + ' SET ( ALLOW_PAGE_LOCKS  = ON )'
				PRINT @alterSql
				EXEC(@alterSql)
				PRINT 'Page lock removed from index: ' + @indexName
				FETCH NEXT FROM indexes INTO @indexName, @qTableName
			END
		CLOSE indexes
		DEALLOCATE indexes
		
		DROP TABLE #index_names
	END


GO
